#include "spad.h"

int initial_verbose = 1;
#ifdef	TELNETD
char trrste;
char trrstm;
char	hisopts[256];
char	myopts[256];
char	doopt[]= { IAC, DO,   '%', 'c', 0 };
char	dont[] = { IAC, DONT, '%', 'c', 0 };
char	will[] = { IAC, WILL, '%', 'c', 0 };
char	wont[] = { IAC, WONT, '%', 'c', 0 };

char	tel_sender[80];
char	tel_defsend[80] = "telnet";
#endif	TELNETD
enum role role;

char *service;
#ifdef	SERVICEFORM
char *service_form;
#endif	SERVICEFORM
char service_buf[128];
char *accntfile;

int  addr_pos = 0;
int  addr_spaces = ADDR_SPACES;
char *addr_space[MAX_ADDR_SPACES] = { ADDR_SPACE };

int xindex = 0;
char suspendc = 'Z' - '@';
char prompt[] = PROMPT;
char localhost[128];
char stdoutbuf[BUFSIZ];
int  pktisize=1024;
#ifdef	POLL_INTERVAL
long poll_interval = POLL_INTERVAL;
#endif	POLL_INTERVAL
int  pktosize=1024;
int  suspendedy = 0;
int  stty_ign	= STTY_IGN;
int  ignore_cont = 0;
FILE *reading = NULL;	/* Am reading from this file (not tty) */
int  reading_pipe;
int  rawtty = 0;
int  have_settty = 0;	/* Have I ever setttu'ed ? */
int  linemode = 0;
int  forbid_some_pad_cmds = 0;
int  forbid_suspend = 0;
int  print_banner	= 1;
int  idle_warns		= 0;
int  idle_grace		= IDLE_GRACE;
#ifdef	TELNETD
int force_echo_on  = TPADECHO_ON;
int force_echo_off = TPADECHO_OFF;
int x_mode = 0;
int y_mode = 1;
int telnet_verbose=0;
int  telnetd = 0;	/* Am I telnet code invoked by inetd */
int  native_telnet= NATIVE_TELNET; /* Leave the TCP link in native mode ? */
#endif	TELNETD
/* COMMUNICATIONS definitions and data structures */


/* (client portion can run on other machines) */

#if defined(sun) && defined(SERVERCODE)
CONN_DB add;
#endif sun && SERVERCODE

#ifdef	DEXPAND
struct ccontrolp contp;
int circuit = -1;
#endif	DEXPAND

#ifdef	SERVERCODE
char *dte;			/* the man we're calling */
char sender[80] = "<Unknown>";
#endif	SERVERCODE

struct x25io x25ibuf, x25obuf, x25sbuf, x25io_tty;

/* structure for logging accounting info. */
#ifdef SERVERCODE
char app_relay[256];

struct x25log x25log;

int s= -1;	/* s is the socket to x25 software (not used in client) */
struct sockaddr_in sin, from;
int servertoclient= -1;		/* server internet socket */
#else	SERVERCODE
#ifdef	TELNETD
struct sockaddr_in from;
#endif	TELNETD
#endif	SERVERCODE
int	pktsout;
int	bytesout;
int	pktsin;
int	bytesin;

#ifdef	TELNETD
char *nullenv[] = {
	(char *) 0
};
char *oldenv[] = {
	"TELNETDBANNER=",
	"TELNETDLOGIN=/bin/Login",
	"TELNETDPTYFIRST=271",
	"TELNETDPTYLAST=240",
	(char *) 0
};
#endif	TELNETD

char *alias[] =
{	ALIAS1_PREFIX,	ALIAS2_PREFIX,	ALIAS3_PREFIX,	ALIAS4_PREFIX,
	ALIAS5_PREFIX,	ALIAS6_PREFIX,	ALIAS7_PREFIX,	ALIAS8_PREFIX,
	ALIAS9_PREFIX,	ALIAS10_PREFIX,	ALIAS11_PREFIX,	ALIAS12_PREFIX,
	ALIAS13_PREFIX,	ALIAS14_PREFIX,	ALIAS15_PREFIX,	ALIAS16_PREFIX,
	ALIAS17_PREFIX,	ALIAS18_PREFIX,	ALIAS19_PREFIX,	ALIAS20_PREFIX
};
int aliases = -1;
char format[] = "SPADALIAS%d_PREFIX";

int clienttoserver= -1;		/* client internet socket */
FILE *termlogf;			/* for logging the terminal session */
int  use_termlogf = 0;		/* logging at the moment ? */

char matchbuf[MAXMATCH];

int matchindex;
int matchnchars = 0;
int matchlen;
char *matchp;
FILE *matchf;
char *scrfn = NULL;			/* script file name */
int matching = 0;
int batch = 0;			/* => run with no terminal (from, eg, "at" */
char *init_comms[MAX_INIT_COMM];
int init_commn=0;
int ybts=0;			/* is this a YBTS connection ? */
int ts29=0;			/* is this a TS29 connection ? */
int echoing;			/* should there be echoing now ? */
/* PAD PARAMETER handling */

char forwardvec[128];		/* when shall I forward? */
char forwarding;		/* Shall I do you now, Sir? */

int params[P_MAX +1];
int ignore_p[P_MAX +1];
int preset_p[P_MAX +1];
int preset_b[P_MAX +1];

#ifdef	SECURITY
char	allow[]	= "ALLOW";
char	block[]	= "BLOCK";
char	nolog[]	= "NOLOG";
char	skip[]	= "SKIP";
int	dontlog	= 0;
#endif	SECURITY

int	eightbitinput = 0x7f;
char	*prof_file;
char	*sysprof_file;
char	*qual_serv;
char	*exp_text;
char	*unqual_data;

char *findusername();
int sess_idle_logout();

char *port;
char *dest;
char *x25_link;
int termwidth = -1;
int last_ts29_push = 0;		/* first read is accept info */
int reverse_charge = 0;


#ifdef	SGTTYB
struct sgttyb sgttyba, sgttybb;	/* one for alteration, one for keeps */
#endif	SGTTYB
#ifdef	TCHARS
struct tchars tcharsa, tcharsb;
#endif	TCHARS
#ifdef	TERMIO
struct termio termioa, termiob;
#endif	TERMIO
#ifdef	TIOCGLTC
struct ltchars ltchara, ltcharb;		/* for t_suspc */
#endif	TIOCGLTC
#ifdef	TIOCLSET
int	lmode;				/* local mode word */
#endif	TIOCLSET
